<template>
  <div class="holder">
    <LineChart :data="data[city]" />
    <RadialChart class="radialChart" :data="data[city]" />
    <BarChart :data="data[city]" /> 
    <select v-model="city">
      <option value="am">dataset 1</option>
      <option value="ny">dataset 2</option>
    </select>
  </div>
</template>
<script>
import LineChart from './components/LineChart'
import RadialChart from './components/RadialChart'
import BarChart from './components/BarChart'

export default {
  data () {
    return {
      data: {am:[], ny:[]},
      city: 'am'
    }
  },
  methods: {
    farentheitToCelcius (val) {
      return ( val - 32 ) * 5 / 9
    },

    handleJSON (json) {
      return {
        date: new Date(json.date),
        high: this.farentheitToCelcius(json.high),
        low: this.farentheitToCelcius(json.low),
        avg: this.farentheitToCelcius(json.avg),
      }
    },

    fetchAndConvertData () {
      Promise.all([
        fetch('/am.json'),
        fetch('/ny.json')
      ])
      .then(responses => Promise.all(responses.map(resp =>  resp.json())))
      .then(([am, ny]) => {
        this.data = {
         am: am.map(d => this.handleJSON(d)),
         ny: ny.map(d => this.handleJSON(d)),
        }
      })
    },
  },

  mounted () {
    this.fetchAndConvertData()
  },

  components: {
    LineChart,
    RadialChart,
    BarChart,
  },
}
</script>

<style>
body {
  background: #383c4a;
}

.holder {
  display: grid;
  grid-template-rows: 300px 300px;
  grid-template-columns: auto 420px;

}

.radialChart {
  grid-column: 2 / 3;
  grid-row: 1 / 3;
}
</style>
